/***************************************************************************
 *                                                                         *
 *   YANN - Yet Another Neural Network                                     *
 *   =================================                                     *
 *                                                                         *
 *   Copyright (C) Juan Pedro Bolivar Puente 2008                          *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#include "inputtask.h"
#include "cleaner.h"

namespace yann
{

bool InputTask::update ()
{
    Value val;

    (*m_in) >> Cleaner ();
    if ((*m_in).eof ())
	return true;

    for (std::list<Input*>::iterator it = m_input.begin ();
	 it != m_input.end ();
	 ++it) {
	(*m_in) >> Cleaner () >> val;
	(*it)->input (val);
    }
    
    return false;
}

} /* namespace yann */
