/***************************************************************************
 *                                                                         *
 *   YANN - Yet Another Neural Network                                     *
 *   =================================                                     *
 *                                                                         *
 *   Copyright (C) Juan Pedro Bolivar Puente 2008                          *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#ifndef YANN_INPUTTASK_H
#define YANN_INPUTTASK_H

#include "task.h"
#include "input.h"

#include <iostream>
#include <list>

namespace yann
{

class InputTask : public Task
{
    std::list<Input*> m_input;
    std::istream* m_in;
    
public:
    InputTask (std::istream* in = 0) :
	m_in (in) {}

    void setStream (std::istream* in) {
	m_in = in;
    }
    
    void addInput (Input* in) {
	m_input.push_back (in);
    }

    bool update ();
};

} /* namespace yann */

#endif /* YANN_INPUTTASK_H */
