/***************************************************************************
 *                                                                         *
 *   YANN - Yet Another Neural Network                                     *
 *   =================================                                     *
 *                                                                         *
 *   Copyright (C) Juan Pedro Bolivar Puente 2008                          *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#ifndef YANN_NETWORK_H
#define YANN_NETWORK_H

#include <iostream>
#include <vector>

#include "input.h"
#include "perceptron.h"
#include "pipeline.h"
#include "inputtask.h"
#include "outputtask.h"

namespace yann
{

class Network
{
    std::vector<Input> m_input;
    std::vector<Perceptron> m_nodes;
    std::vector<Pipeline> m_layers;
    InputTask m_input_task;
    OutputTask m_output_task;
    
public:
    Network (std::istream& file);
    
    void run (std::istream& in,
	      std::ostream& out);
};

} /* namespace yann */

#endif /* YANN_NETWORK_H */
