/***************************************************************************
 *                                                                         *
 *   YANN - Yet Another Neural Network                                     *
 *   =================================                                     *
 *                                                                         *
 *   Copyright (C) Juan Pedro Bolivar Puente 2008                          *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#ifndef YANN_OUTPUTTASK_H
#define YANN_OUTPUTTASK_H

#include "task.h"
#include "node.h"

#include <iostream>
#include <list>

namespace yann
{

class OutputTask : public Task
{    
    std::list<Node*> m_node;
    std::ostream* m_out;
    
public:
    OutputTask (std::ostream* out = 0) :
	m_out (out) {}

    void setStream (std::ostream* out) {
	m_out = out;
    }
    
    void addOutput (Node* nod) {
	m_node.push_back (nod);
    }

    bool update ();
};

} /* namespace yann */

#endif /* YANN_OUTPUTTASK_H */
