/***************************************************************************
 *                                                                         *
 *   YANN - Yet Another Neural Network                                     *
 *   =================================                                     *
 *                                                                         *
 *   Copyright (C) Juan Pedro Bolivar Puente 2008                          *
 *                                                                         *
 *   This program is free software: you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation, either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include "perceptron.h"

namespace yann
{

bool Perceptron::update ()
{
    m_output = m_bias;

    std::list<Link>::iterator it = m_input.begin ();
    while (it != m_input.end ()) {
	m_output += it->weight * it->node->output ();

#ifdef DEBUG
	std::cout << "w: " << it->weight
		  << " o: " << it->node->output ()
		  << " so: " << m_output << std::endl;
#endif
	
	it++;
    }

    if (m_out_func)
	m_output = m_out_func (m_act_func (m_output));
    else
	m_output = m_act_func (m_output);

#ifdef DEBUG
    std::cout << "m_result " << m_output << std::endl;
    std::cout << "--------------" << endl;
#endif
    
    return false;
}

} /* namespace yann */
